"""
Requirements:
    selenium 
    python
    "geckodriver.exe" web driver. the file is located under the folder
    "Firefox"

This peice of code will
    1: login to your google acount by your email and password
    2: send a query to google scholar (you must specified the search string)
    3: select all resulted papers as your intrests. as a result the selected papers will be stored in your scholar Library
    4: then you can run the bibtex_exporter.py file to export results in Bibtex format

Set the following variable in code:
    1: set_executable_path    -> line 63
    2: set_sign_in            -> line 64
    3: set_email_address      -> line 65
    4: set_password           -> line 66
    5: set_search_string      -> line 67
    6: set_your_library_link  -> line 68
    7: set_output_directory   -> line 69

Note
    BOT OT NOT
        it happens that google stop the process to check whether you are a bot or not.
        if it happens exactly after you have been signed in by the code, you have 2 min to prove yourself by answering google's question. if you answer them correctly the process will continue else it will stop
        in the case where it happens during the main process (because of too many hits) you must start the process again. but you can start it from the point where you are process stoped.
        to start from that point just copy the url from address bar and change the set_search_string variable with the new url.
        
    
    Developer
        these scripts has been written by Amir Mohammad Ebrahimi as a part of Systematic literature Review project
        the access is free for anyone and feel free to develop the code.
    

        labratory web page:
            Intelligent System Laboratory
                http://islab.ceit.aut.ac.ir/
        
        my web page:
            http://islab.ceit.aut.ac.ir/amirmohammad-ebrahimi/
            
        my email address:
            amirebrahimi@aut.ac.ir

"""

import time
import sys, io
from selenium import webdriver
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.common.proxy import *
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.by import By
from selenium.webdriver.common.action_chains import ActionChains
from selenium.common.exceptions import StaleElementReferenceException
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.keys import Keys


set_exec_path = ''
set_sign_in   = 'https://accounts.google.com/signin/v2/identifier?hl=en&continue=https%3A%2F%2Fscholar.google.com%2F&flowName=GlifWebSignIn&flowEntry=ServiceLogin&cid=1&navigationDirection=forward'
set_email_address = ''
set_password = ''
set_search_string = ''
set_your_library_link = ''
set_output_directory = 'papers.txt'

driver = webdriver.Firefox(executable_path=set_exec_path)
driver.implicitly_wait(2)
wait = WebDriverWait( driver, 10 )


def driver_get_page(driver, url):
    try:
        driver.get(url)
 
    except Exception:
        driver.refresh()


def has_next_btn(driver):
    next_btns = driver.find_elements(By.LINK_TEXT, "Next")
    if len(next_btns) == 1:
        return True
    else:
        return False

# address of google's sign-in page
sign_in = set_sign_in
try:
    driver_get_page(driver,sign_in)
except Exception:
    driver_get_page(driver,sign_in);

time.sleep(1)
email_box = driver.find_elements(By.CSS_SELECTOR ,"input[class*='whsOnd zHQkBf']")[0]
email_box.send_keys(set_email_address)
email_box.send_keys(Keys.RETURN);


time.sleep(2)
pass_box = driver.find_elements(By.CSS_SELECTOR ,"input[class*='whsOnd zHQkBf']")[0]
pass_box.send_keys(set_password)
pass_box.send_keys(Keys.RETURN);

time.sleep(2)

#to set the address. pay attention to the following instruction 
# 1: login to your google account
# 2: type https://scholar.google.com/ in your browser an press enter
# 3: click on "My library" at the left corner of your browser
# 4: copy the your library url from the address bar
# 5: pase it between the quotation
# for example:
#   my_library_link = 'https://scholar.google.com/scholar?start=770&hl=en&as_sdt=0,5&scilib=1'
my_library_link = set_your_library_link

try:
    driver_get_page(driver,my_library_link)
except Exception:
    driver_get_page(driver,my_library_link);

# you have 2 min to prove you are not a bot. answer google questions. 
# if google does not ask you any thing just wait for a 60 sed
time.sleep(60) 

while True:

    check_all_btn = driver.find_elements(By.ID ,"gs_res_ab_xall")[0]
    check_all_btn.click()

    export_btn  = driver.find_elements(By.ID ,"gs_res_ab_exp-b")[0]
    export_btn.click()

    export_div  = driver.find_elements(By.CSS_SELECTOR ,"div[class*='gs_md_ul gs_md_ul_tb gs_md_ulr']")[0]
    export_options = export_div.find_elements_by_tag_name("a")
    export_options[0].click()

    # [0] for Bibtex  (supported)
    # [1] for EndNote (not supported now)
    # [2] for RefMan  (not supported now)
    # [3] for Csv not (not supported now)
    export_page = driver.find_elements_by_tag_name("pre")[0]


    # set the directory where you want to save the papers' citations
    with open(set_output_directory, 'a', encoding='utf-8') as wr:
        wr.write(export_page.text)
        wr.write('\n')

    time.sleep(1)

    driver.execute_script("window.history.go(-1)")

    if has_next_btn(driver):
        driver.find_element(By.LINK_TEXT, "Next").click()
    else:
        break

