"""
Requirements:
    selenium 
    python
    "geckodriver.exe" web driver. the file is located under the folder
    "Firefox"

Scripts of code will
    1: login to your google acount by your email and password
    2: send a query to google scholar (you must specified the search string)
    3: select all resulted papers as your intrests. as a result the selected papers will be stored in your scholar Library
    4: then you can run the bibtex_exporter.py file to export results in Bibtex format

Set the following variable in code:
    1: set_executable_path    -> line 61
    2: set_sign_in            -> line 62
    3: set_email_address      -> line 63
    4: set_password           -> line 64
    5: set_search_string      -> line 65

Note
    BOT OT NOT
        it happens that google stop the process to check whether you are a bot or not.
        if it happens exactly after you have been signed in by the code, you have 2 min to prove yourself by answering google's question. if you answer them correctly the process will continue else it will stop
        in the case where it happens during the main process (because of too many hits) you must start the process again. but you can start it from the point where you are process stoped.
        to start from that point just copy the url from address bar and change the set_search_string variable with the new url.

Constarints
    you are allowed to save results of the first 100 pages
    the format of citation is BibTex

Developer
    these scripts has been written by Amir Mohammad Ebrahimi as a part of Systematic literature Review project
    the access is free for anyone and feel free to develop the code.
    
    labratory web page:
        Intelligent System Laboratory
            http://islab.ceit.aut.ac.ir/
    
    my web page:
        http://islab.ceit.aut.ac.ir/amirmohammad-ebrahimi/
        
    my email address:
        amirebrahimi@aut.ac.ir

"""

import time
import sys, io
from selenium import webdriver
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.common.proxy import *
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.by import By
from selenium.webdriver.common.action_chains import ActionChains
from selenium.webdriver.common.keys import Keys
from selenium.common.exceptions import StaleElementReferenceException
from selenium.webdriver.support import expected_conditions as EC

set_exec_path = ''
set_sign_in   = 'https://accounts.google.com/signin/v2/identifier?hl=en&continue=https%3A%2F%2Fscholar.google.com%2F&flowName=GlifWebSignIn&flowEntry=ServiceLogin&cid=1&navigationDirection=forward'
set_email_address = ''
set_password = ''
set_search_string = ''


# set the path to the place where you put geckodriver.exe file
driver = webdriver.Firefox(executable_path=set_exec_path)
driver.implicitly_wait(2)
wait = WebDriverWait( driver, 10 )

    
def driver_get_page(driver, url):
    try:
        driver.get(url)
 
    except Exception:
        driver.refresh()


def has_next_btn(driver):
    next_btns = driver.find_elements(By.LINK_TEXT, "Next")
    if len(next_btns) == 1:
        return True
    else:
        return False

# address of google's sign-in page
sign_in = set_sign_in

try:
    driver_get_page(driver,sign_in)
except Exception:
    driver_get_page(driver,sign_in);

time.sleep(1)
email_box = driver.find_elements(By.CSS_SELECTOR ,"input[class*='whsOnd zHQkBf']")[0]
email_box.send_keys(set_email_address) # set your email address. note that the email should be verified by google
email_box.send_keys(Keys.RETURN);


time.sleep(2)
pass_box = driver.find_elements(By.CSS_SELECTOR ,"input[class*='whsOnd zHQkBf']")[0]
pass_box.send_keys(set_password) # set your password
pass_box.send_keys(Keys.RETURN);

time.sleep(5)
# set your search string
# it's a query that want to fetch papers about. for example "requirement elicitation"
# it could be constructed by ligical operation like AND, OR
# type your search string in google scholar and press enter then copy the address for address bar and put it there between quotations
# for example : 
    # query = 'https://scholar.google.com/scholar?q=requirement+elicitation&hl=en&as_sdt=0,5'
query = set_search_string

try:
    driver_get_page(driver,query)
except Exception:
    driver_get_page(driver,query);

time.sleep(120) # you have 2 min to prove you are not a bot. just answer google questions and then the process 

while True:
    intrest_btns = driver.find_elements(By.CSS_SELECTOR ,"a[class*='gs_or_sav']")

    for btn in intrest_btns:
        btn.click()

    time.sleep(1)

    if has_next_btn(driver):
        driver.find_element(By.LINK_TEXT, "Next").click()
    else:
        break



